unit pteststrings;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvMemo, AdvMemoStylerManager,
  atScript, atPascal,
  ScripterInit, atParser,
  ap_Classes, ap_StdCtrls,
  AdvmPS, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    AdvPascalMemoStyler1: TAdvPascalMemoStyler;
    Button1: TButton;
    Panel1: TPanel;
    memo_out: TAdvMemo;
    Splitter1: TSplitter;
    memo_in: TAdvMemo;
    procedure Button1Click(Sender: TObject);
    procedure script_VM(AMachine: TatVirtualMachine);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

function e_test_strs(var qstrs: tobject; qstr: string): boolean;
function e_get_app_folder : string;
procedure add_DefineMethod;



var
  Form1: TForm1;
  fscripter :  TatPascalScripter;
implementation

{$R *.dfm}
//------------------------------------------------------------------------------
procedure TForm1.script_VM(AMachine: TatVirtualMachine);
var qstra : string; inta : integer;    qstrs : tobject;
begin

With AMachine do begin



 If lowercase(CurrentMethodName) = 'e_get_app_folder' then ReturnOutputArg(e_get_app_folder);

 If lowercase(CurrentMethodName) = 'e_test_strs' then begin
   qstrs := GetInputArgasobject(0);
  ReturnOutputArg(e_test_strs( qstrs, GetInputArgAsString(1)));
   SetInputArg(0,ObjectToVar(qstrs));
 end;



end;

end;
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
procedure add_DefineMethod;
begin
  fscripter.DefineMethod('e_get_app_folder',0,tkString,nil,pteststrings.Form1.script_VM,false,0);
  fscripter.DefineMethod('e_test_strs',2,tkinteger,nil,pteststrings.Form1.script_VM,false,2);
end;
//------------------------------------------------------------------------------
function e_get_app_folder : string;
begin
  result := ExtractFilePath(application.ExeName);
  result := system.sysutils.IncludeTrailingPathDelimiter(result) ;
end;
//------------------------------------------------------------------------------
function e_test_strs(var qstrs: tobject; qstr: string): boolean;
begin
//if assigned(qstrs) = false then  qstrs := tstringlist.Create;
(qstrs as tstringlist).Add(qstr);
end;
//------------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
var qvar : variant;  qstr : string;
begin

  fscripter :=  TatPascalScripter.Create(nil);
  fscripter.AddLibrary(TatClassesLibrary);
  fscripter.DefineClassByRTTI(TStrings);
  fscripter.DefineClassByRTTI(tstringlist);
  FScripter.AddLibrary(TatStdCtrlsLibrary);

add_DefineMethod;
fscripter.SourceCode.Text :=  pteststrings.Form1.memo_in.lines.Text;
qvar := pteststrings.fscripter.Execute() ;
qstr := vartostr(qvar);
pteststrings.Form1.memo_out.Lines.Add(qstr) ;


pteststrings.fscripter.Destroy;

end;
//------------------------------------------------------------------------------


end.
